use smartstring::{LazyCompact, SmartString};
use std::collections::HashMap;

pub type Data = SmartString<LazyCompact>;

type Args = Option<Vec<Data>>;
type Config = Option<HashMap<String, String>>;

#[derive(Debug, Default)]
pub struct Routes {
    storage: Vec<Route>,
}

#[derive(Debug, Default)]
pub struct Route {
    pub cfg: Config,
    pub route: Data,
    pub args: Args,
    pub fn_name: Data,
    pub fn_body: Data,
}

impl Routes {
    pub fn new_cached() -> Self { Routes { storage: Vec::new() } }

    pub fn get(&self) -> &Vec<Route> { &self.storage }

    pub fn get_mut(&mut self) -> &mut Vec<Route> { &mut self.storage }
}

pub mod prelude {
    pub use super::Data as RouteData;
    pub use super::Route;
    pub use super::Routes;
}
